diff -crN nakedmudv1.5/doc/README nakedmudv2.0/doc/README
*** nakedmudv1.5/doc/README	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/doc/README	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,4 ****
! NakedMud version 0.1
  
  NakedMud is a project I started up to keep myself entertained, and fool around
  with a couple ideas I could not work with on the MUD I run. The basic idea
--- 1,4 ----
! NakedMud version 2.0
  
  NakedMud is a project I started up to keep myself entertained, and fool around
  with a couple ideas I could not work with on the MUD I run. The basic idea
diff -crN nakedmudv1.5/lib/misc/help nakedmudv2.0/lib/misc/help
*** nakedmudv1.5/lib/misc/help	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/misc/help	2010-11-01 15:54:18.000000000 -0500
***************
*** 44,49 ****
--- 44,112 ----
        socunlink [command]
        socedit [social]
        socials
+   backups  :=
+     keywords : socials
+     editor   : Alister
+     timestamp: Jan 29 18:52:49
+     info     :~
+       There are 9 fields assocciated with social editing; two are for messages when
+       the social has no target. Two are for messages when the target is the character
+       performing the social. Three are for situations when a target other than the
+       character is provided for the social. The remaining two are the minimum and
+       maximum positions the socials can be used from. If a social is not to have a
+       target, the "target" fields can be left blank. Likewise, if the social is never
+       to have the character as a target, the assocciated fields can be left blank.
+       When trying to reference character information, the following symbols can be
+       used:
+       
+         $n character name
+         $N target name
+         $e character he/she
+         $E target he/she
+         $m character him/her
+         $M target him/her
+         $s character his/hers
+         $S target his/hers
+       
+       To see examples of how to write socials, check some of the pre-existing ones.
+       To generate a list of all socials, type "socials".
+       
+       If you would like more than one command to trigger the same social, you can
+       link a new command to a pre-existing social. Likewise, if you would like to
+       disable a social command, that is possible too.
+       
+       Commands:
+         hlink [new command] [old command]
+         hunlink [command]
+         socedit [social]
+         socials
+     -
+     keywords : socials
+     editor   : Alister
+     timestamp: Jan 29 17:03:12
+     info     :~
+       There are 9 fields assocciated with social editing; two are for messages when
+       the social has no target. Two are for messages when the target is the character
+       performing the social. Three are for situations when a target other than the
+       character is provided for the social. The remaining two are the minimum and
+       maximum positions the socials can be used from. If a social is not to have a
+       target, the "target" fields can be left blank. Likewise, if the social is never
+       to have the character as a target, the assocciated fields can be left blank.
+       When trying to reference character information, the following symbols can be
+       used:
+       
+         $n character name
+         $N target name
+         $e character he/she
+         $E target he/she
+         $m character him/her
+         $M target him/her
+         $s character his/hers
+         $S target his/hers
+       
+       To see examples of how to write socials, check some of the pre-existing ones.
+       To generate a list of all socials, type "socials".
+     -
    -
    keywords : MCCP
    editor   : Alister
***************
*** 117,122 ****
--- 180,204 ----
        help
      
      See also: WRITE
+   backups  :=
+     keywords : help
+     editor   : Alister
+     timestamp: Jan 29 18:31:08
+     info     :~
+       There are various tools available for creating and editing helpfiles. You
+       can update the contents of any helpfile with the hupdate command. The
+       contents of your notepad (see: write) will be transferred to the helpfile.
+       You can also link a new word to an already existing helpfile with the hlink
+       command. Unlinking is also possible with the hunlink command.
+       
+       Commands:
+         hupdate [helpfile]
+         hlink [new topic] [old topic]
+         hunlink [topic]
+         help
+       
+       See also: WRITE
+     -
    -
    keywords : dig, fill
    editor   : Alister
diff -crN nakedmudv1.5/lib/misc/socials nakedmudv2.0/lib/misc/socials
*** nakedmudv1.5/lib/misc/socials	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/misc/socials	2010-11-01 15:54:18.000000000 -0500
***************
*** 19,24 ****
--- 19,33 ----
    min_pos      : standing
    max_pos      : standing
    -
+   cmds         : ponder
+   to_char_notgt: You sink deeply into your thoughts.
+   to_room_notgt: $n sinks deeply into $s thoughts.
+   to_char_tgt  : You ponder the plight of $N.
+   to_vict_tgt  : $n looks to be deep in thought at $e stares at you.
+   to_room_tgt  : $n looks deep in thought as $e stares at $N.
+   min_pos      : sitting
+   max_pos      : flying
+   -
    cmds         : snicker
    to_char_notgt: You snicker softly.
    to_room_notgt: $n snickers softly.
diff -crN nakedmudv1.5/lib/misc/time nakedmudv2.0/lib/misc/time
*** nakedmudv1.5/lib/misc/time	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/misc/time	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,6 ****
! hour        : 18
! day_of_week : 2
! day_of_month: 11
! month       : 2
! year        : 0
  -
--- 1,6 ----
! hour        : 23
! day_of_week : 1
! day_of_month: 10
! month       : 1
! year        : 1
  -
diff -crN nakedmudv1.5/lib/txt/greeting nakedmudv2.0/lib/txt/greeting
*** nakedmudv1.5/lib/txt/greeting	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/txt/greeting	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,5 ****
  {n
!                     NakedMud(tm), content-less MUD engine.
  
                                    Created By
                                   Geoff Hollis
--- 1,5 ----
  {n
!                    NakedMud(tm) v2.0, content-less MUD engine.
  
                                    Created By
                                   Geoff Hollis
diff -crN nakedmudv1.5/lib/world/0/zone nakedmudv2.0/lib/world/0/zone
*** nakedmudv1.5/lib/world/0/zone	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/world/0/zone	2010-11-01 15:54:18.000000000 -0500
***************
*** 5,16 ****
  name       : The null zone
  desc       :~
       This zone has no purpose and should be taken out when the MUD is first 

- auxiliary  :-
-   zone_map_data :-
-     zone_display_map: 0
-     -
-   autopilot_data:-
-     autopilot_on: 0
-     -
-   -
  -
--- 5,8 ----
diff -crN nakedmudv1.5/lib/world/1/mobs nakedmudv2.0/lib/world/1/mobs
*** nakedmudv1.5/lib/world/1/mobs	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/world/1/mobs	2010-11-01 15:54:18.000000000 -0500
***************
*** 15,38 ****
    race      : human
    dialog    : 100
    auxiliary :-
!     stat_data        :-
!       health          : 5
!       curr_health     : 5
!       power           : 5
!       curr_power      : 0
!       awareness       : 5
!       curr_awareness  : 0
!       courage         : 5
!       curr_courage    : 0
!       control         : 5
!       curr_control    : 0
!       speed           : 5
!       curr_speed      : 0
!       personality     : 5
!       curr_personality: 0
        -
      script_aux_data  :-
        scripts:=
          vnum: 150
          -
          vnum: 140
--- 15,38 ----
    race      : human
    dialog    : 100
    auxiliary :-
!     combat_state_data:-
!       health      : 100
!       curr_health : 100
!       power       : 100
!       curr_power  : 100
!       control     : 100
!       curr_control: 100
!       defense     : 100
!       curr_defense: 100
!       agility     : 100
!       curr_agility: 100
!       wits        : 100
!       curr_wits   : 100
        -
      script_aux_data  :-
        scripts:=
+         vnum: 195
+         -
          vnum: 150
          -
          vnum: 140
***************
*** 54,74 ****
    race      : human
    dialog    : 101
    auxiliary :-
!     stat_data        :-
!       health          : 5
!       curr_health     : 5
!       power           : 5
!       curr_power      : 0
!       awareness       : 5
!       curr_awareness  : 0
!       courage         : 5
!       curr_courage    : 0
!       control         : 5
!       curr_control    : 0
!       speed           : 5
!       curr_speed      : 0
!       personality     : 5
!       curr_personality: 0
        -
      script_aux_data  :-
        scripts:=
--- 54,72 ----
    race      : human
    dialog    : 101
    auxiliary :-
!     combat_state_data:-
!       health      : 100
!       curr_health : 100
!       power       : 100
!       curr_power  : 100
!       control     : 100
!       curr_control: 100
!       defense     : 100
!       curr_defense: 100
!       agility     : 100
!       curr_agility: 100
!       wits        : 100
!       curr_wits   : 100
        -
      script_aux_data  :-
        scripts:=
***************
*** 93,113 ****
    race      : human
    dialog    : 102
    auxiliary :-
!     stat_data        :-
!       health          : 5
!       curr_health     : 5
!       power           : 5
!       curr_power      : 0
!       awareness       : 5
!       curr_awareness  : 0
!       courage         : 5
!       curr_courage    : 0
!       control         : 5
!       curr_control    : 0
!       speed           : 5
!       curr_speed      : 0
!       personality     : 5
!       curr_personality: 0
        -
      -
    -
--- 91,109 ----
    race      : human
    dialog    : 102
    auxiliary :-
!     combat_state_data:-
!       health      : 100
!       curr_health : 100
!       power       : 100
!       curr_power  : 100
!       control     : 100
!       curr_control: 100
!       defense     : 100
!       curr_defense: 100
!       agility     : 100
!       curr_agility: 100
!       wits        : 100
!       curr_wits   : 100
        -
      -
    -
***************
*** 128,148 ****
    race      : human
    dialog    : -1
    auxiliary :-
!     stat_data        :-
!       health          : 5
!       curr_health     : 5
!       power           : 5
!       curr_power      : 0
!       awareness       : 5
!       curr_awareness  : 0
!       courage         : 5
!       curr_courage    : 0
!       control         : 5
!       curr_control    : 0
!       speed           : 5
!       curr_speed      : 0
!       personality     : 5
!       curr_personality: 0
        -
      -
    -
--- 124,142 ----
    race      : human
    dialog    : -1
    auxiliary :-
!     combat_state_data:-
!       health      : 100
!       curr_health : 100
!       power       : 100
!       curr_power  : 100
!       control     : 100
!       curr_control: 100
!       defense     : 100
!       curr_defense: 100
!       agility     : 100
!       curr_agility: 100
!       wits        : 100
!       curr_wits   : 100
        -
      -
    -
diff -crN nakedmudv1.5/lib/world/1/objs nakedmudv2.0/lib/world/1/objs
*** nakedmudv1.5/lib/world/1/objs	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/world/1/objs	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,14 ****
  list:=
    vnum      : 100
-   type      : 2
-   subtype   : 0
-   value 0   : 0
-   value 1   : 0
-   value 2   : 0
-   value 3   : 0
-   value 4   : 0
    weight    : 1.000000
-   capacity  : 0.000000
    name      : a white cotton shirt
    keywords  : shirt
    rdesc     : A revealing, white cotton shirt is lying here.
--- 1,6 ----
***************
*** 18,34 ****
      woman.
    multiname : %d white cotton shirts
    multirdesc: A pile of %d white cotton shirts has formed, here.
    -
    vnum      : 101
-   type      : 2
-   subtype   : 4
-   value 0   : 0
-   value 1   : 0
-   value 2   : 0
-   value 3   : 0
-   value 4   : 0
    weight    : 0.100000
-   capacity  : 0.000000
    name      : a pair of long, dangly earrings
    keywords  : earrings
    rdesc     : A pair of long, dangly earrings are lying here.
--- 10,28 ----
      woman.
    multiname : %d white cotton shirts
    multirdesc: A pile of %d white cotton shirts has formed, here.
+   auxiliary :-
+     type_data      :-
+       types:=
+         type: worn
+         data:-
+           type: shirt
+           -
+         -
+       -
+     -
    -
    vnum      : 101
    weight    : 0.100000
    name      : a pair of long, dangly earrings
    keywords  : earrings
    rdesc     : A pair of long, dangly earrings are lying here.
***************
*** 37,53 ****
      whenever they are turned in the light.
    multiname : %d sets of long dangly earrings
    multirdesc: %d pairs of long, dangly earrings are lying here.
    -
    vnum      : 120
-   type      : 4
-   subtype   : 0
-   value 0   : 5
-   value 1   : 0
-   value 2   : 0
-   value 3   : 0
-   value 4   : 0
    weight    : 80.000000
-   capacity  : 0.000000
    name      : a wooden table
    keywords  : table
    rdesc     : An empty table is here.
--- 31,49 ----
      whenever they are turned in the light.
    multiname : %d sets of long dangly earrings
    multirdesc: %d pairs of long, dangly earrings are lying here.
+   auxiliary :-
+     type_data      :-
+       types:=
+         type: worn
+         data:-
+           type: earrings
+           -
+         -
+       -
+     -
    -
    vnum      : 120
    weight    : 80.000000
    name      : a wooden table
    keywords  : table
    rdesc     : An empty table is here.
***************
*** 57,92 ****
      could seat about four or five people at it.
    multiname : %d wooden tables
    multirdesc: There are %d empty tables scattered around.
!   bits      : a
    -
    vnum      : 130
-   type      : 4
-   subtype   : 0
-   value 0   : 12
-   value 1   : 0
-   value 2   : 0
-   value 3   : 0
-   value 4   : 0
    weight    : 500.000000
-   capacity  : 0.000000
    name      : the bar
    keywords  : bar
    rdesc     : A long bar counter is here, lined with seats.
    desc      :~
         It is about twenty feet long, and it is lined with stools.  It is made 
      out of a polished, dark wood.
!   bits      : a
    -
    vnum      : 140
-   type      : 5
-   subtype   : 0
-   value 0   : 1
-   value 1   : -1
-   value 2   : 0
-   value 3   : 0
-   value 4   : 0
    weight    : 0.100000
-   capacity  : 1.000000
    name      : a small leather coin pouch
    keywords  : pouch
    rdesc     : A small leather coin pouch is here.
--- 53,94 ----
      could seat about four or five people at it.
    multiname : %d wooden tables
    multirdesc: There are %d empty tables scattered around.
!   obj_bits  : notake
!   auxiliary :-
!     type_data      :-
!       types:=
!         type: furniture
!         data:-
!           capacity: 5
!           type    : 0
!           -
!         -
!       -
!     -
    -
    vnum      : 130
    weight    : 500.000000
    name      : the bar
    keywords  : bar
    rdesc     : A long bar counter is here, lined with seats.
    desc      :~
         It is about twenty feet long, and it is lined with stools.  It is made 
      out of a polished, dark wood.
!   obj_bits  : notake
!   auxiliary :-
!     type_data      :-
!       types:=
!         type: furniture
!         data:-
!           capacity: 9
!           type    : 0
!           -
!         -
!       -
!     -
    -
    vnum      : 140
    weight    : 0.100000
    name      : a small leather coin pouch
    keywords  : pouch
    rdesc     : A small leather coin pouch is here.
***************
*** 104,120 ****
          threads.  It is a bit frayed, but looks quite durable.
        -
      -
    -
    vnum      : 141
-   type      : 0
-   subtype   : 0
-   value 0   : 0
-   value 1   : 0
-   value 2   : 0
-   value 3   : 0
-   value 4   : 0
    weight    : 0.200000
-   capacity  : 0.000000
    name      : a pint of ale
    keywords  : pintglass, glass, ale
    rdesc     : A pint of ale has been left here.
--- 106,129 ----
          threads.  It is a bit frayed, but looks quite durable.
        -
      -
+   auxiliary :-
+     type_data      :-
+       types:=
+         type: container
+         data:-
+           capacity : 2.000000
+           key      : -1
+           pick_diff: 0
+           closable : 1
+           closed   : 0
+           locked   : 0
+           -
+         -
+       -
+     -
    -
    vnum      : 141
    weight    : 0.200000
    name      : a pint of ale
    keywords  : pintglass, glass, ale
    rdesc     : A pint of ale has been left here.
diff -crN nakedmudv1.5/lib/world/1/scripts nakedmudv2.0/lib/world/1/scripts
*** nakedmudv1.5/lib/world/1/scripts	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/world/1/scripts	2010-11-01 15:54:18.000000000 -0500
***************
*** 75,82 ****
    narg: 0
    name: Crowd Cheering
    code:~
!     # When someone gets on stage, the crod starts cheering, adding a
!     # bit of flavor.
      ch.send("{yAs you get up on stage, you hear hoots and hollers from below. It looks like the crowd is waiting you to start performing.")
    -
    vnum: 140
--- 75,82 ----
    narg: 0
    name: Crowd Cheering
    code:~
!     # Whensomeone gets on stage, the crowd starts cheering, adding a
!     # bit of flavor to this special exit
      ch.send("{yAs you get up on stage, you hear hoots and hollers from below. It looks like the crowd is waiting you to start performing.")
    -
    vnum: 140
***************
*** 162,167 ****
--- 162,182 ----
      if obj != None and ch.on == None and obj.vnum == 130:
        me.act("delay 1 say what can I get for you? If you'd like to know what we have on tap, please ask")
    -
+   vnum: 195
+   type: 1
+   narg: 0
+   name: How to exit a script
+   args: hello
+   code:~
+     # At times, you will want to exit a script prematurely. This example script
+     # Shows you how it is done.
+     
+     # only trigger the script for PCs
+     if ch.is_npc:
+       exit()
+     else:
+       me.act("say Hello, " + ch.name)
+   -
    vnum: 196
    type: 1
    narg: 0
diff -crN nakedmudv1.5/lib/world/1/zone nakedmudv2.0/lib/world/1/zone
*** nakedmudv1.5/lib/world/1/zone	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/lib/world/1/zone	2010-11-01 15:54:18.000000000 -0500
***************
*** 7,18 ****
       The ambition of this zone is to act as a repository for "proofs of 
    concept".  Hopefully, there will be enough examples in this zone to act as a 
  editors    : Alister
- auxiliary  :-
-   zone_map_data :-
-     zone_display_map: 0
-     -
-   autopilot_data:-
-     autopilot_on: 0
-     -
-   -
  -
--- 7,10 ----
diff -crN nakedmudv1.5/src/action.c nakedmudv2.0/src/action.c
*** nakedmudv1.5/src/action.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/action.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 33,40 ****
  #include "character.h"
  #include "action.h"
  
  typedef struct action_data ACTION_DATA;
! HASHMAP *actors = NULL;
  
  struct action_data {
    void (*  on_complete)(void *ch, void *data, bitvector_t where, char *arg);
--- 33,44 ----
  #include "character.h"
  #include "action.h"
  
+ #ifdef MODULE_FACULTY
+ #include "faculty/faculty.h"
+ #endif
+ 
  typedef struct action_data ACTION_DATA;
! MAP *actors = NULL;
  
  struct action_data {
    void (*  on_complete)(void *ch, void *data, bitvector_t where, char *arg);
***************
*** 98,103 ****
--- 102,115 ----
  }
  
  
+ // used to kill all of a character's actions on death
+ void stop_all_actions(CHAR_DATA *ch) {
+ #ifdef MODULE_FACULTY
+   interrupt_action(ch, FACULTY_ALL);
+ #else
+   interrupt_action(ch, 1);  
+ #endif
+ }
  
  
  //*****************************************************************************
***************
*** 107,117 ****
  //*****************************************************************************
  void init_actions() {
    // use the standard pointer hasher and comparator
!   actors = newHashmap(NULL, NULL, 50);
  
    // add in our example delayed action
    add_cmd("dsay", NULL, cmd_dsay, 0, POS_SITTING, POS_FLYING, 
  	  LEVEL_ADMIN, TRUE, FALSE);
  }
  
  bool is_acting(void *ch, bitvector_t where) {
--- 119,132 ----
  //*****************************************************************************
  void init_actions() {
    // use the standard pointer hasher and comparator
!   actors = newMap(NULL, NULL, 50);
  
    // add in our example delayed action
    add_cmd("dsay", NULL, cmd_dsay, 0, POS_SITTING, POS_FLYING, 
  	  LEVEL_ADMIN, TRUE, FALSE);
+ 
+   // make sure the character does not continue actions after being extracted
+   add_extract_mob_func(stop_all_actions);
  }
  
  bool is_acting(void *ch, bitvector_t where) {
diff -crN nakedmudv1.5/src/action.d nakedmudv2.0/src/action.d
*** nakedmudv1.5/src/action.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/action.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ action.d action.o: action.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h character.h action.h
diff -crN nakedmudv1.5/src/alias/alias.d nakedmudv2.0/src/alias/alias.d
*** nakedmudv1.5/src/alias/alias.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/alias/alias.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ alias/alias.d alias/alias.o: alias/alias.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h auxiliary.h storage.h \
+   character.h alias/alias.h
diff -crN nakedmudv1.5/src/autorun.py nakedmudv2.0/src/autorun.py
*** nakedmudv1.5/src/autorun.py	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/autorun.py	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,43 ----
+ ################################################################################
+ #
+ # autorun.py
+ #
+ # This autorun script was designed to be used with NakedMud. It will 
+ # automagically restart your MUD any time it crashes. If the MUD is manually
+ # shut down, the autorun script will terminate. 
+ #
+ # Geoff Hollis
+ # http://www.ualberta.ca/~hollis/nakedmud.html
+ #
+ ################################################################################
+ 
+ from time import sleep   # we delay before restarting
+ from os   import system  # to start running the MUD
+ 
+ # how long do we delay before a restart (seconds)
+ restart_delay = 5
+ 
+ # the path to the MUD binary
+ path = './NakedMud'
+ 
+ # the port we will be running the MUD under
+ port = 4000
+ 
+ # the command we execute to boot up the MUD
+ cmd  = "%s %d" % (path, port)
+ 
+ # now, while we have not exited without an error, run the MUD 
+ # and reboot it every time we exit with an error (we crash)
+ while True:
+     # run the MUD
+     status = system(cmd)
+ 
+     # exited normally
+     if status == 0:
+ 	break;
+     else:
+ 	# We should probably see if we can figure out what kind of
+ 	# error caused the crash here, and report it
+ 
+ 	# wait out our delay, then restart the MUD
+ 	sleep(restart_delay)
diff -crN nakedmudv1.5/src/auxiliary.c nakedmudv2.0/src/auxiliary.c
*** nakedmudv1.5/src/auxiliary.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/auxiliary.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 90,101 ****
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
  
!   while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!     funcs = hashIteratorCurrentVal(hash_i);
!     hashIteratorNext(hash_i);
      if(IS_SET(funcs->aux_type, aux_type))
        hashPut(data, name, funcs->new());
-   }
    deleteHashIterator(hash_i);
    return data;
  }
--- 90,98 ----
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
  
!   ITERATE_HASH(name, funcs, hash_i)
      if(IS_SET(funcs->aux_type, aux_type))
        hashPut(data, name, funcs->new());
    deleteHashIterator(hash_i);
    return data;
  }
***************
*** 107,118 ****
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
  
!   while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!     funcs = hashIteratorCurrentVal(hash_i);
!     hashIteratorNext(hash_i);
      if(IS_SET(funcs->aux_type, aux_type) && !hashGet(data, name))
        hashPut(data, name, funcs->new());
-   }
    deleteHashIterator(hash_i);
  }
  
--- 104,112 ----
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
  
!   ITERATE_HASH(name, funcs, hash_i) 
      if(IS_SET(funcs->aux_type, aux_type) && !hashGet(data, name))
        hashPut(data, name, funcs->new());
    deleteHashIterator(hash_i);
  }
  
***************
*** 125,133 ****
    void            *entry  = NULL;
    const char      *name   = NULL;
  
!   while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!     entry = hashIteratorCurrentVal(hash_i);
!     hashIteratorNext(hash_i);
      funcs = auxiliariesGetFuncs(name);
      funcs->delete(entry);
    }
--- 119,125 ----
    void            *entry  = NULL;
    const char      *name   = NULL;
  
!   ITERATE_HASH(name, entry, hash_i) {
      funcs = auxiliariesGetFuncs(name);
      funcs->delete(entry);
    }
***************
*** 144,152 ****
    void            *entry  = NULL;
    const char      *name   = NULL;
  
!   while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!     entry = hashIteratorCurrentVal(hash_i);
!     hashIteratorNext(hash_i);
      funcs = auxiliariesGetFuncs(name);
      store_set(set, name, funcs->store(entry));
    }
--- 136,142 ----
    void            *entry  = NULL;
    const char      *name   = NULL;
  
!   ITERATE_HASH(name, entry, hash_i) {
      funcs = auxiliariesGetFuncs(name);
      store_set(set, name, funcs->store(entry));
    }
***************
*** 162,170 ****
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
  
!   while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!     funcs = hashIteratorCurrentVal(hash_i);
!     hashIteratorNext(hash_i);
      if(!IS_SET(funcs->aux_type, aux_type))
        continue;
      hashPut(data, name, funcs->read(read_set(set, name)));
--- 152,158 ----
    AUXILIARY_FUNCS *funcs = NULL;
    const char       *name = NULL;
  
!   ITERATE_HASH(name, funcs, hash_i) {
      if(!IS_SET(funcs->aux_type, aux_type))
        continue;
      hashPut(data, name, funcs->read(read_set(set, name)));
***************
*** 184,192 ****
    // first, delete all of the old data
    if(hashSize(to) > 0) {
      hash_i = newHashIterator(to);
!     while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!       entry = hashIteratorCurrentVal(hash_i);
!       hashIteratorNext(hash_i);
        funcs = auxiliariesGetFuncs(name);
        funcs->delete(entry);
      }
--- 172,178 ----
    // first, delete all of the old data
    if(hashSize(to) > 0) {
      hash_i = newHashIterator(to);
!     ITERATE_HASH(name, entry, hash_i) {
        funcs = auxiliariesGetFuncs(name);
        funcs->delete(entry);
      }
***************
*** 196,204 ****
    // now, copy in all of the new data
    if(hashSize(from) > 0) {
      hash_i = newHashIterator(from);
!     while( (name = hashIteratorCurrentKey(hash_i)) != NULL) {
!       entry = hashIteratorCurrentVal(hash_i);
!       hashIteratorNext(hash_i);
        funcs = auxiliariesGetFuncs(name);
        hashPut(to, name, funcs->copy(entry));
      }
--- 182,188 ----
    // now, copy in all of the new data
    if(hashSize(from) > 0) {
      hash_i = newHashIterator(from);
!     ITERATE_HASH(name, entry, hash_i) {
        funcs = auxiliariesGetFuncs(name);
        hashPut(to, name, funcs->copy(entry));
      }
diff -crN nakedmudv1.5/src/auxiliary.d nakedmudv2.0/src/auxiliary.d
*** nakedmudv1.5/src/auxiliary.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/auxiliary.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ auxiliary.d auxiliary.o: auxiliary.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h storage.h auxiliary.h
diff -crN nakedmudv1.5/src/auxiliary.h nakedmudv2.0/src/auxiliary.h
*** nakedmudv1.5/src/auxiliary.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/auxiliary.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 18,23 ****
--- 18,24 ----
  #define AUXILIARY_TYPE_ROOM      (1 << 1)
  #define AUXILIARY_TYPE_OBJ       (1 << 2)
  #define AUXILIARY_TYPE_ZONE      (1 << 3)
+ #define AUXILIARY_TYPE_SOCKET    (1 << 4)
  
  
  //
